/* config.hh: configuration definitions

   Copyright (c) 1989 James E. Wilson

   This software may be copied and distributed for educational, research, and
   not for profit purposes provided that this copyright and statement are
   included in all such copies. */

/* The config.hh thing is a hack so that the Makefile works correctly.
	Here's what's going on:  if you run "make debugging", then make
	copies config.hh into config.h and adds the line "#define DEBUGGING"
	By default is just copies config.hh into config.h
*/
#ifndef ABYSS_CONFIG_INCLUDED
#define ABYSS_CONFIG_INCLUDED

/* Person to bother if something goes wrong. */
/* Recompile files.c and misc2.c if these change. */
#define WIZARD	"jlm (Jacob Mandelson)"
/* wizard password and wizard uid no longer used */


/* files used by moria, set these to valid pathnames */

/* probably unix */
#define ANGBAND_TST       LIBDIR"/test"
#define ANGBAND_HOU       LIBDIR"/files/hours"
#define ANGBAND_MOR       LIBDIR"/files/news"
#define ANGBAND_TOP       LIBDIR"/files/scores"
#define ANGBAND_BONES     LIBDIR"/bones/"
#define ANGBAND_HELP      LIBDIR"/files/commands.hlp"
/* #define ANGBAND_ORIG_HELP LIBDIR"/files/origcmds.hlp" */
/* #define ANGBAND_WIZ_HELP  LIBDIR"/files/rwizcmds.hlp" */
#define ANGBAND_OWIZ_HELP LIBDIR"/files/owizcmds.hlp"
#define ANGBAND_WELCOME   LIBDIR"/files/welcome.hlp"
#define ANGBAND_LOG       LIBDIR"/files/ANGBAND.log"
#define ANGBAND_VER       LIBDIR"/files/version.hlp"
#define ANGBAND_LOAD      LIBDIR"/files/loadcheck"
#define ANGBAND_WIZ       LIBDIR"/files/wizards"
#define ANGBAND_SAV       LIBDIR"/save"

/*#define ANNOY 142*/
 /* #define SET_UID */
#define SET_GID

/* this sets the default user interface */
/* to use the original key bindings (keypad for movement) set ROGUE_LIKE
   to FALSE, to use the rogue-like key bindings (vi style movement)
   set ROGUE_LIKE to TRUE */
/* if you change this, you only need to recompile main.c */
#define ROGUE_LIKE TRUE


/* for the ANDREW distributed file system, define this to ensure that
   the program is secure with respect to the setuid code, this prohibits
   inferior shells, also does not relinquish setuid priviledges at the start,
   but instead calls the ANDREW library routines bePlayer(), beGames(),
   and Authenticate() */
/* #define SECURE */


/* no system definitions are needed for 4.3BSD, SUN OS, DG/UX */

/* if you are compiling on an ultrix/4.2BSD/Dynix/etc. version of UNIX,
   define this, not needed for SUNs */
/* #ifndef ultrix
#define ultrix
#endif */

/* if you are compiling on a SYS V version of UNIX, define this */
/* #define SYS_V */

/* if you are compiling on a SYS III version of UNIX, define this */
/* #define SYS_III */

/* if you are compiling on an ATARI ST with Mark Williams C, define this */
/* #define ATARIST_MWC */

/* if you are compiling on a Macintosh with MPW C 3.0, define this */
/* #define MAC */


/* system dependent defines follow, you should not need to change anything
   below */

/* substitute strchr for index on USG versions of UNIX */
#if defined(SYS_V) || defined(MSDOS) || defined(MAC)
#define index strchr
#endif

#ifdef SYS_III
char *index();
#endif

#if defined(SYS_III) || defined(SYS_V) || defined(MSDOS) || defined(MAC)
#ifndef USG
#define USG
#endif
#endif

#ifdef ATARIST_MWC
#define USG
#endif

/* Pyramid runs 4.2BSD-like UNIX version */
#if defined(Pyramid)
#define ultrix
#endif

#ifdef MSDOS
#define register      /* MSC 4.0 still has a problem with register bugs ... */
#endif

#ifdef MAC
#ifdef RSRC
#define MACRSRC		/* i.e., we're building the resources */
#else
#define MACGAME		/* i.e., we're building the game */
#endif
#endif

#ifdef MAC
/* Screen dimensions */
#define SCRN_ROWS	24
#define SCRN_COLS	80
#endif

#if vms
#define getch _getch
#define unlink delete
#define index strchr
#define lstat stat
#define exit uexit
#endif

#if defined(SYS_V) && defined(lint)
/* to prevent <string.h> from including <NLchar.h>, this prevents a bunch
   of lint errors. */
#define RTPC_NO_NLS
#endif

#ifdef SECURE
extern int PlayerUID;
#define getuid() PlayerUID
#define geteuid() PlayerUID
#endif

/* Conditions I added for conditional compilation.
	DEBUGGING	If defined, will add some debugging code.  Should be #undef
			for all release versions.
	FILE_LOCKING	If defined, Abyss will get a lock on the high score
			file before using it.
	DUMPING_CORE	if #undef'd, Abyss will try to use rlimit to disable
			core dumps
	USLEEP		If defined, Abyss uses usleep() to pause, otherwise
			it uses sleep().
	USE_NCURSES		If defined, Abyss uses the ncurses I/O library, otherwise
			it uses the curses library.
		Warning:  The code included by this option is probably highly
			unportable, and should not be used unless you are experienced 
			in ncurses and willing to port to your system.
	PROTOTYPES		If defined, Abyss includes some prototypes to make 
			debugging easier.  Still incomplete, unfortunately.
	ANSI_COLOR		If defined, Abyss uses the ANSI escape sequences for 
			color (as a option).  DO NOT use if you have USE_NCURSES defined.

					--- JLM */

/* undef DEBUGGING */
#undef FILE_LOCKING
#define DUMPING_CORE
#undef USLEEP
#undef USE_NCURSES
#define PROTOTYPES
#define ANSI_COLOR

#endif		/* ABYSS_CONFIG_INCLUDED	*/
