/*	cyber.c		-- cybernetic spell code	
**	Copyright	Jacob L. Mandelson	1994
**				California Inst. of Tech.
**				This code can be freely distributed, etc.
*/

#include "constant.h"
#include "config.h"
#include "types.h"
#include "externs.h"

void cyber_spell()		/* Cast a spell.	*/
{
	int i, j, item_val, dir, choice, chance, result;
	register struct flags *f_ptr;
	register struct misc *p_ptr;
	register inven_type *i_ptr;
	register spell_type *m_ptr;

	free_turn_flag = TRUE;
	if (py.flags.confused>0)
		msg_print("You are too confused.");
	else if (py.misc.pclass!=CL_CYBORG && py.misc.pclass!=CL_ROBOT)
		msg_print("You lack the equipment to run programs.");
	else if (!find_range(TV_CD_ROM, TV_NEVER, &i, &j))
		msg_print("You have no CDs!");
	else if (get_item(&item_val, "Use which CD-ROM?", i, j, 0))
	{
		result = cast_spell("Run which program?", item_val, &choice, &chance);
		if (py.flags.stun>50) chance+=25;
		else if (py.flags.stun>0) chance+=15;
		if (result<0)
			msg_print("You haven't learned any programs from that disk.");
		else if (result>0)
		{
			m_ptr=&magic_spell[py.misc.pclass-1][choice];
			free_turn_flag=FALSE;

			if (randint(100)<chance)
				msg_print("Error running program.");
			else
			{  /* Spells at last! */
				switch(choice+1)
				{
				case 1:	/* Neural shock */
					if (get_dir(NULL, &dir))
						fire_bolt(GF_MAGIC_MISSILE, dir, char_row, char_col,
							damroll(2,6), spell_names[0]);
					break;
				case 2:	/* Detect sounds == Detect monsters */
					(void) detect_monsters();
					break;
				case 3:	/* Phase self == blink */
					teleport(10);
					break;
				case 4: /* Light area */
					(void) light_area(char_row, char_col);
					break;
				case 5:
					(void) detect_treasure();
					break;
				case 6: /* Minor repairs */
					(void) hp_player(damroll(4,4));
					if (py.flags.cut>0) {
						py.flags.cut-=15;
						if (py.flags.cut<0) py.flags.cut=0;
						msg_print("Your wounds close.");
					}
					break;
				case 7:
					(void) detect_object();
					break;
				case 8:
					(void) detect_sdoor();
					(void) detect_trap();
					break;
				case 9: /* Adrenaline rush */
					msg_print("Adrenaline flows through your veins.");
					py.flags.shero += randint(25)+25;
					break;
				case 10: /* neural blast */
					if (get_dir(NULL, &dir))
						fire_ball(GF_MAGIC_MISSILE, dir , char_row, char_col,
						10+(py.misc.lev/2), spell_names[9]);
					break;
				case 11: /* Thought blender == Confuse monster */
					if (get_dir(NULL, &dir))
				{	msg_print("You point your finger and channel your power.");
					(void) confuse_monster(dir, char_row, char_col); }
				break;
				case 12: /* Neural sear */
					if (get_dir(NULL, &dir))
						fire_bolt(GF_MAGIC_MISSILE, dir, char_row, char_col,
							damroll(3+((py.misc.lev-5)/4),8), spell_names[11]);
					break;
				case 13: /* Disarm */
					(void) trap_destroy();
					break;
				case 14: /* Knockout */
					(void) sleep_monsters2();
					break;
				case 15: /* Filter blood */
					(void) cure_poison();
				case 16: /* Transport self */
					teleport((int)(py.misc.lev*5));
					break;
				case 17: /* Laser beam */
					if (get_dir(NULL, &dir))
					{	msg_print("Your brilliant laser strikes out.");
						light_line(dir, char_row, char_col);
					}
					break;
				case 18:
					if (get_dir(NULL, &dir))
						fire_bolt(GF_LIGHTNING, dir, char_row, char_col,
							damroll(5+((py.misc.lev-5)/4),8), spell_names[17]);
					break;
				case 19: /* recharging */
					(void) recharge(5);
					break;
				case 20: /* Instant mutation == polymorph */
					if (get_dir(NULL, &dir))
						(void) poly_monster(dir, char_row, char_col);
					break;
				case 21: /* encyclopedic ref. == identify */
					(void) ident_spell();
					break;
				case 22: /* Energy bolt */
					if (get_dir(NULL, &dir))
						fire_bolt(GF_MAGIC_MISSILE, dir, char_row, char_col,
							damroll(8+((py.misc.lev-3)/3),8), spell_names[21]);
					break;
				case 23: /* Atrophy muscles == slow */
					if (get_dir(NULL, &dir))
						(void) speed_monster(dir, char_row, char_col, -1);
					break;
				case 24: /* Ball lightning */
					if (get_dir(NULL, &dir))
						fire_ball(GF_LIGHTNING, dir, char_row, char_col,
							30+(py.misc.lev), spell_names[23]);
					break;
				case 25: /* phase other == teleport away */
					if (get_dir(NULL,  &dir))
						(void) teleport_monster(dir, char_row, char_col);
					break;
				case 26:
					f_ptr = &py.flags;
					if (f_ptr->fast<=0)
						f_ptr->fast+=randint(20)+py.misc.lev;
					else
						f_ptr->fast+=randint(5);
					break;
				case 27: /* Energy ball */
					if (get_dir(NULL, &dir))
						fire_ball(GF_MAGIC_MISSILE, dir, char_row, char_col,
							55+(py.misc.lev), spell_names[26]);
				case 28: /* Destruction */
					destroy_area(char_row, char_col);
					break;
				case 29: /* Exterminate */
					(void) genocide(TRUE);
					break;
				case 30: /* Long-Range Teleportation == Teleport level */
					(void) tele_level();
					break;
				case 31: /* Mass extermination */
					(void) mass_genocide(TRUE);
					break;
				case 32: /* subspace sweep == Detection */
					(void) detection();
					break;
				case 33: /* karmic shield */
					py.flags.shield += randint(20)+30;	
					calc_bonuses();
					prt_pac();
					break;
				case 34: /* electric shielding */
					py.flags.invuln += randint(9)+6;
					break;
				case 35: /* concentration == heroism */
					py.flags.hero += randint(25)+25;
					break;
				case 36: /* earthquake */
					earthquake();
					break;
				case 37: /* seismic mapping == magic mapping */
					map_area();
					break;
				default: break;
			}	/* That's all folks! */
		if (!free_turn_flag)
		{
			p_ptr = &py.misc;
			if (choice<32) 
			{	if ((spell_worked & (1L << choice))==0) {
					p_ptr->exp += m_ptr->sexp << 2;
					spell_worked |= (1L << choice);
					prt_experience();
				}}
			else
				{if ((spell_worked2 & (1L << (choice-32)))==0){
					p_ptr->exp += m_ptr->sexp << 2;
					spell_worked2 |= (1L << (choice-32));
					prt_experience();
				}}
		}
		}
	p_ptr= &py.misc;
	if (!free_turn_flag)
	{
		if (m_ptr->smana > p_ptr->cmana)
		{
			msg_print("You faint from the effort!");
			py.flags.paralysis = 
				randint((int)(5*(m_ptr->smana-p_ptr->cmana)));
			p_ptr->cmana=0;
			p_ptr->cmana_frac = 0;
			if (randint(3)==1)
			{
				msg_print("You have damaged your health!");
				(void) dec_stat(A_CON);
			}
		}
		else p_ptr->cmana -= m_ptr->smana;
		prt_cmana();
	}
}}}

int trap_destroy()
{
	register int i,j, destroy;
	register cave_type *c_ptr;

	destroy=FALSE;
	for (i=char_row-1; i<=char_row+1; i++)
		for (j=char_col-1; j<=char_col+1; j++)
		{
			c_ptr=&cave[i][j];
			if (c_ptr->tptr != 0)
			{
				if ((t_list[c_ptr->tptr].tval == TV_INVIS_TRAP) ||
					(t_list[c_ptr->tptr].tval == TV_VIS_TRAP))
				{ if (delete_object(i,j)) destroy=TRUE; }
				else if (t_list[c_ptr->tptr].tval == TV_CHEST)
				{	/* Disarm and unlock chest. */
					t_list[c_ptr->tptr].flags &= ~(CH_TRAPPED|CH_LOCKED);
					t_list[c_ptr->tptr].name2 = SN_DISARMED;
					msg_print("You have disarmed the chest.");
					known2(&t_list[c_ptr->tptr]);
					destroy=TRUE;
				}
			}
		}
	return (destroy);
}


void activate_implant()
{
	int i, flag, redraw, j;
	int num=0, first=0;
	char out_str[200], choice, tmp[200], tmp2[200];
	int k=char_row, l=char_col;
	int dir;
	
	free_turn_flag = TRUE;
	flag = FALSE;	redraw = FALSE;
	for (i=22; i<(INVEN_ARRAY_SIZE-1); i++)
		if (inventory[i].tval == TV_IMPLANT)
		{
			num++;
			if (!flag) first=i;
			flag=TRUE;
		}
	if (!flag) {
		msg_print("You have no implants to be activated.");
		return;
	}
	sprintf(out_str, "Activate which item? (%c-%c, * to list, ESC to exit) ?",
		'a', 'a'+(num-1));
	flag = FALSE;
	while (!flag && get_com(out_str, &choice))
	{
		if (choice=='*')
		{	save_screen();
			j=0;
			if (!redraw) {
				for (i=first; i<(INVEN_ARRAY_SIZE); i++)
				  if (inventory[i].tval != TV_NOTHING)
					{	objdes(tmp2, &inventory[i], TRUE);
						sprintf(tmp, "%c) %-40s", 'a'+j, tmp2);
						prt(tmp, 1+j, 36);
						j++;
					}
			  redraw=TRUE;
			  continue;
			}
		} else {
			if (choice>='A' && choice<=('A'+(num-1)))
				choice-='A';
			else if (choice>='a' && choice<=('a'+(num-1)))
				choice-='a';
			else if (choice=='\033') {
				if (redraw) restore_screen();
			free_turn_flag=TRUE;
			break;	
		}
		if (redraw) restore_screen();
		if (choice>num) continue;
		flag=TRUE;
		i= first+choice;
		if (inventory[i].shots>0)
		{	msg_print("It doesn't have enough power.");
			break;	}
		if (py.stats.use_stat[A_APT]<randint(18) &&
		   randint(inventory[i].p1)>py.misc.lev)
			{	msg_print("You fail to activate it properly.");
				break;	}
		msg_print("You activate the implant.");
		inventory[i].shots = inventory[i].maxshots;
		switch (inventory[i].subval)
		{
			case 0: /* Laser */
				msg_print("You fire a laser beam.");
				if (py.flags.confused > 0)
				{	msg_print("You are confused.");
					do {dir = randint(9);} while (dir==5);
				}	else {
				while (!get_dir(NULL, &dir)) {}
				}
				light_line(dir, char_row, char_col);
				break;
			case 1: /* Electric Shock */
				msg_print("You fire a bolt of electricity.");
				if (py.flags.confused > 0)
				{ msg_print("You are confused.");
					do {dir = randint(9);} while (dir==5);
				} else { while (!get_dir(NULL, &dir)) {} }
				fire_bolt(GF_LIGHTNING, dir, k, l, 
						damroll(3,8), "electric bolt");
				break;
			case 2: /* Cold blast */
				msg_print("You create a blast of bone-numbing cold.");
				if (py.flags.confused > 0)
				{ msg_print("You are confused.");
					do {dir=randint(9);} while (dir == 5);
				} else { while (!get_dir(NULL, &dir)) {}	}
				fire_bolt(GF_FROST, dir, k,l, damroll(4,8),
						"blast of cold");
				break;
			case 3:	/* Fire blast */
				msg_print("You create a blast of fire.");
				if (py.flags.confused > 0)
				{ msg_print("You are confused.");
					do {dir=randint(9);} while (dir==5);
				} else { while (!get_dir(NULL, &dir)) {}	}
				fire_bolt(GF_FIRE, dir, k,l, damroll(6,8),
					"blast of flame");
				break;
			case 4: /* sonic disruption */
				msg_print("You focus an untrasonic pulse.");
				if (py.flags.confused > 0)
				{ msg_print("You are confused.");
					do {dir=randint(9);} while (dir==5);
				} else { while (!get_dir(NULL, &dir)) {}	}
				wall_to_mud(dir, k , l);
				break;
			case 5: /* Mutation */
				msg_print("You let fly a spray of mutagen.");
				if (py.flags.confused > 0)
				{ msg_print("You are confused.");
					do {dir=randint(9);} while (dir==5);
				} else { while(!get_dir(NULL, &dir)) {}	}
				poly_monster(dir, k, l);
				break;
			case 6:	/* Monster Healing */
				msg_print("You let fly a spray of... medicine???");
				if (py.flags.confused > 0)
				{ msg_print("You are confused.");
					do {dir=randint(9);} while (dir==5);
				} else { while(!get_dir(NULL, &dir)) {}	}
				hp_monster(dir, k, l, -damroll(4,6));
				break;
			case 9: /* Confusion */
				msg_print("You let fly a spray of mind altering substances.");
				if (py.flags.confused > 0)
				{ msg_print("You are confused.");
					do {dir=randint(9);} while (dir==5);
				} else { while(!get_dir( NULL, &dir)) {} 	}
				confuse_monster(dir, k, l);
				break;
			case 10: /* Sleep */
				msg_print("You let fly a spray of anaesthetic");
				if (py.flags.confused > 0)
				{ msg_print("You are confused.");
					do {dir=randint(9);} while(dir==5);
				} else { while (!get_dir(NULL, &dir)) {}	}
				confuse_monster(dir, k, l);
				break;
			case 11: /* Life drain */
				msg_print("You send out a bolt of negative-lifeforce.");
				if (py.flags.confused > 0)	
				{ msg_print("You are confused.");
					do {dir=randint(9);} while (dir==5);
				} else { while (!get_dir(NULL, &dir)) {} }
				drain_life(dir, k, l, 75);
				break;
			case 13: /* Neural Shock */
				msg_print("You send out a neural shock wave.");
				if (py.flags.confused > 0)
				{ msg_print("You are confused.");
					do {dir=randint(9);}	while (dir==5);
				} else { while(!get_dir(NULL, &dir)) {}	}
				fire_bolt(GF_MAGIC_MISSILE, dir, k, l, damroll(2,6),
					"neural shock");
				break;
			case 16: /* Transport away */
				msg_print("You send forth a transport beam.");
				if (py.flags.confused > 0)
				{	msg_print("You are confused.");
					do {dir=randint(9);}	while (dir==5);
				} else { while (!get_dir(NULL, &dir)) {} }
				teleport_monster(dir, k, l);
				break;
			case 17:
				if (py.flags.confused > 0)
				{ msg_print("You are confused.");
					do {dir=randint(9);}	while (dir==5);
				}	else { while (!get_dir(NULL, &dir)) {}	}
				disarm_all(dir, k, l);
				break;
			case 18:
				msg_print("You create a storm of electricity.");
				if (py.flags.confused > 0)
				{msg_print("You are confused.");
					do {dir=randint(9);}	while (dir==5);
				} else { while (!get_dir(NULL, &dir)) {}	}
				fire_ball(GF_LIGHTNING, dir, k, l, 32, 
					"storm of electricity");
				break;
			default:
				msg_print("Internal error in activate_implant() ");
				break;
		}
		identify(&i);
}}}
